//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//
//    originaly developed by Markos Katsanos
//    first published in TASC june 2004
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DarkGray
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern double VfiCoeff      = 0.2;
extern double VfiMinPeriod  = 130;
extern double VfiMaxPeriod  = 170;
extern int    VfiPrice      = PRICE_TYPICAL;
extern double VolumeCoeff   = 2.5;
extern int    SmoothPeriod  = 3;
extern int    CfbDepth      = 3;
extern int    CfbSmooth     = 8;
extern int    CfbNormLength = 50;
extern bool   Interpolate   = true;

//
//
//
//
//

double vfi[];
double vfs[];
double vfsua[];
double vfsub[];
double cfbb[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,vfi);
   SetIndexBuffer(1,vfs);
   SetIndexBuffer(2,vfsua);
   SetIndexBuffer(3,vfsub);
   SetIndexBuffer(4,cfbb);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //

   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][6];
#define _price  0
#define _volume 1
#define _voluma 2
#define _dvol   3
#define _vfi    4
#define _trend  5

//
//
//
//
//

int start()
{
   int i,r,n,k,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { vfi[0] = MathMin(limit+1,Bars-1); return(0); }
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (work[Bars-limit-1][_trend]==-1) CleanPoint(limit,vfsua,vfsub);
      double alpha = 2.0 / (1.0+SmoothPeriod);    
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         work[r][_price]  = iMA(NULL,0,1,0,MODE_SMA,VfiPrice,i);
         work[r][_volume] = Volume[i];
         work[r][_voluma] = 0;

            if (r==0) continue;

            cfbb[i] = iCfb(work[r][_price],CfbDepth,CfbSmooth,i);
         
            //
            //
            //
            //
            //
         
            double max = cfbb[ArrayMaximum(cfbb,CfbNormLength,i)];
            double min = cfbb[ArrayMinimum(cfbb,CfbNormLength,i)];
            double denominator = max-min;
               if (denominator> 0)
                     double ratio = (cfbb[i]-min)/denominator;
               else         ratio = 0.5;  
               int VfiPeriod = MathMax(VfiMinPeriod+ratio*(VfiMaxPeriod-VfiMinPeriod),3); 
               work[r][_voluma] = work[r][_volume]; for (k=1; k<VfiPeriod; k++) work[r][_voluma] += work[r-k][_volume];
               work[r][_voluma] /= VfiPeriod*1.00;
            
         //
         //
         //
         //
         //
         
            double mf     = work[r][_price]-work[r-1][_price];
            double inter  = MathLog(work[r][_price])-MathLog(work[r-1][_price]);
            double vinter = iDeviation(inter,30,i);
            double cutoff = VfiCoeff * vinter * Close[i];
            double vave   = work[r-1][_voluma];
            double vmax   = vave*VolumeCoeff;
            double vc     = MathMin(work[r][_volume],vmax);
            double directionalVolume = 0;
               if (mf> cutoff) directionalVolume =  vc;
               if (mf<-cutoff) directionalVolume = -vc;
         
               //
               //
               //
               //
               //
            
               work[r][_dvol]  = directionalVolume;
               work[r][_vfi]   = directionalVolume;  for (k=1; k<VfiPeriod; k++) work[r][_vfi] += work[r-k][_dvol];
               if (vave!=0)
                     work[r][_vfi] /= vave;
               else  work[r][_vfi] = 0;
               work[r][_trend] = work[r-1][_trend];
         
            vfi[i]   = work[r][_vfi];
            vfs[i]   = vfs[i+1]+alpha*(work[r][_vfi]-vfs[i+1]);
            vfsua[i] = EMPTY_VALUE;
            vfsub[i] = EMPTY_VALUE;
               if (vfs[i]>0) work[r][_trend]= 1;
               if (vfs[i]<0) work[r][_trend]=-1;
               if (work[r][_trend]==1)
                  PlotPoint(i,vfsua,vfsub,vfs);
      }
      return(0);
   }
   
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (work[Bars-limit-1][_trend]==-1) CleanPoint(limit,vfsua,vfsub);
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         vfi[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VfiCoeff,VfiMinPeriod,VfiMaxPeriod,VfiPrice,VolumeCoeff,SmoothPeriod,CfbDepth,CfbSmooth,CfbNormLength,0,y);
         vfs[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VfiCoeff,VfiMinPeriod,VfiMaxPeriod,VfiPrice,VolumeCoeff,SmoothPeriod,CfbDepth,CfbSmooth,CfbNormLength,1,y);
         vfsua[i] = EMPTY_VALUE;
         vfsub[i] = EMPTY_VALUE;
            if (vfs[i]>0) work[r][_trend]= 1;
            if (vfs[i]<0) work[r][_trend]=-1;
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               vfi[i+k] = vfi[i] + (vfi[i+n] - vfi[i]) * k/n;
               vfs[i+k] = vfs[i] + (vfs[i+n] - vfs[i]) * k/n;
            }
   }
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++) if (work[r][_trend]==1) PlotPoint(i,vfsua,vfsub,vfs);
   return(0);
         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double array[];
double iDeviation(double value, double period, int i)
{
   if (ArraySize(array)!=Bars) ArrayResize(array,Bars); i= Bars-i-1; array[i] = value;
   double avg = 0; for(int k=0; k<period; k++) avg += array[i-k]; avg /= period;
   double sum = 0; for(    k=0; k<period; k++) sum += (array[i-k]-avg)*(array[i-k]-avg);
   return(MathSqrt(sum/period));
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int    Depths[] = {2,3,4,6,8,12,16,24,32,48,64,96,128,192};
double workCfb[][28];

//
//
//
//
//

double iCfb(double price, int depth, int smooth, int r)
{
   if (ArrayRange(workCfb,0) != Bars) ArrayResize(workCfb,Bars);
   int i = Bars-r-1;
         
   //
   //
   //
   //
   //

   double suma     = 0;
   double sumb     = 0;
   double cfb      = 0;
   double evenCoef = 1;
   double oddCoef  = 1;
   double avg      = 0;
         
      if (i>=smooth)
         for (int k=depth-1; k>=0; k--)
         {
            workCfb[i][k]    = iCfbFunc(price,i,Depths[k],k);
            workCfb[i][k+14] = workCfb[i-1][k+14] + (workCfb[i][k]-workCfb[i-smooth][k])/smooth;

                  if ((k%2)==0)
                        { avg = oddCoef  * workCfb[i][k+14]; oddCoef  = oddCoef  * (1 - avg); }
                  else  { avg = evenCoef * workCfb[i][k+14]; evenCoef = evenCoef * (1 - avg); }
               
               suma += avg*avg*Depths[k];
               sumb += avg;
         }
      else for (k=depth-1; k>=0; k--) { workCfb[i][k] = 0; workCfb[i][k+14] = 0; }            

   //
   //
   //
   //
   //

   if (sumb != 0) cfb = suma/sumb;
   return(cfb);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double  workCfbFunc[][70];
#define _prices 0
#define _roc    1
#define _value1 2
#define _value2 3
#define _value3 4

//
//
//
//

double iCfbFunc(double price, int r, int depth, int k)
{
   k *= 5;
      if (ArrayRange(workCfbFunc,0) != Bars) ArrayResize(workCfbFunc,Bars);
      if (r<=(depth+1))
      {
         workCfbFunc[r][k+_prices] = 0;
         workCfbFunc[r][k+_roc]    = 0;
         workCfbFunc[r][k+_value1] = 0;
         workCfbFunc[r][k+_value2] = 0;
         workCfbFunc[r][k+_value3] = 0;
         return(0);
      }         
      workCfbFunc[r][k+_prices] = price; 

   //
   //
   //
   //
   //

      workCfbFunc[r][k+_roc]    = MathAbs(workCfbFunc[r][k+_prices] - workCfbFunc[r-1][k+_prices]);
      workCfbFunc[r][k+_value1] = workCfbFunc[r-1][k+_value1] - workCfbFunc[r-depth][k+_roc] + workCfbFunc[r][k+_roc];
      workCfbFunc[r][k+_value2] = workCfbFunc[r-1][k+_value2] - workCfbFunc[r-1][k+_value1] + workCfbFunc[r][k+_roc]*depth;
      workCfbFunc[r][k+_value3] = workCfbFunc[r-1][k+_value3] - workCfbFunc[r-1-depth][k+_prices] + workCfbFunc[r-1][k+_prices];
   
      double dividend = MathAbs(depth*workCfbFunc[r][k+_prices]-workCfbFunc[r][k+_value3]);

      //
      //
      //
      //
      //
         
   if (workCfbFunc[r][k+_value2] != 0)
         return( dividend / workCfbFunc[r][k+_value2]);
   else  return(0.00);            
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}